#extension GL_ARB_draw_buffers : enable

uniform sampler2D texture0;
uniform vec4 fogcolor;
uniform vec2 fogangle;

varying vec3 cubecoord;
varying vec4 fragcolor;

void main(void) {
	vec4 color;//=textureCube(texture0,cubecoord) * fragcolor;
	
	vec3 sundir=vec3(1,1,1);
	sundir=normalize(sundir);

	float d=clamp(-dot(sundir,normalize(cubecoord)*2.0-1.0),0,1);
	//color = d * vec4(0.75,0.75,1,1) + (1.0 - d) * vec4(0.1,0.1,0.25,1);
	
	float zenith = d;
	float midpoint = abs(d-0.5);
	float bottom = 1.0 - d;
	
	color = zenith * texture2D(texture0,vec2(0.5/256.0,1.0));
	;//color = midpoint * texture2D(texture0,vec2(0.5/256.0,0.5));
	color += bottom * texture2D(texture0,vec2(0.5/256.0,0.0));
	
	//Horizon fog effect
	vec3 normal=normalize(cubecoord);
	normal.y=max(normal.y,0.0);
	float angle=asin(normal.y)*57.2957795-fogangle.x;
	float fogeffect=1.0-clamp(angle/(fogangle.y-fogangle.x),0.0,1.0);
	fogeffect *= fogcolor.w;
	color=color*(1.0-fogeffect)+fogeffect*fogcolor;
	
	angle = asin(d)*57.2957795;
	if (angle<15.0) {
	//	color=vec4(1.0);
	}
	
	gl_FragData[0] = color;
	gl_FragData[1] = vec4(1.0,1.0,1.0,0.0);
	gl_FragData[2] = vec4(0.0);
	gl_FragData[3] = color*0.5*(1.0-fogeffect);
}