uniform sampler2D texture15;
uniform vec2 buffersize;
uniform vec3 terrainscale;

varying vec4 color;

void main(void) {
	
	vec3 normal;

	vec2 ps=1.0/buffersize;
	vec2 texcoord=gl_FragCoord.xy/buffersize;
	
	texcoord=vec2(texcoord.x,1.0-texcoord.y);

	float tl=texture2D(texture15,texcoord+vec2(+ps.x,+ps.y)).x;//GetHeight(grid_x-1,grid_y-1);
	float tm=texture2D(texture15,texcoord+vec2(0.0,-ps.y)).x;//GetHeight(grid_x,grid_y-1);
	float tr=texture2D(texture15,texcoord+vec2(+ps.x,-ps.y)).x;//GetHeight(grid_x+1,grid_y-1);
	float ml=texture2D(texture15,texcoord+vec2(-ps.x,0.0)).x;//GetHeight(grid_x-1,grid_y);
	float mm=texture2D(texture15,texcoord).x;//GetHeight(grid_x,grid_y);
	float mr=texture2D(texture15,texcoord+vec2(+ps.x,0.0)).x;//GetHeight(grid_x+1,grid_y);
	float bl=texture2D(texture15,texcoord+vec2(-ps.x,+ps.y)).x;//GetHeight(grid_x-1,grid_y+1);
	float bm=texture2D(texture15,texcoord+vec2(0.0,+ps.y)).x;//GetHeight(grid_x,grid_y+1);
	float br=texture2D(texture15,texcoord+vec2(+ps.x,+ps.y)).x;//GetHeight(grid_x+1,grid_y+1);
	
	float isq2=0.707106781;
	float sum=1.0+isq2+isq2;
		
	float al=(tl*isq2+ml+bl*isq2)/sum;
	float ar=(tr*isq2+mr+br*isq2)/sum;
	float at=(tl*isq2+tm+tr*isq2)/sum;
	float ab=(bl*isq2+bm+br*isq2)/sum;
	
	normal.x=(al-ar);
	normal.y=(at-ab);
	float m=max(0.0,normal.x*normal.x+normal.y*normal.y);
	m=min(m,1.0);
	
	normal.z=sqrt(1.0-m);
	
	float meterspertile=1.0;

	float height = 10000.0 / 100.0 * terrainscale.y / meterspertile / 255.0;
	//float height = 10000.0 / 255.0;
	
	//If (height != 0.0) {
		normal.z/=height;
		m=sqrt(normal.x*normal.x+normal.y*normal.y+normal.z*normal.z);
		normal.x/=m;
		normal.y/=m;
		normal.z/=m;
	//}
	
	gl_FragColor = vec4( normal.xzy*0.5+0.5,1.0 );
}
