#extension GL_ARB_draw_buffers : enable

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2; //normal
uniform sampler2D texture3;
uniform sampler2D texture7;
uniform vec2 buffersize;

void main(void) {
	
	vec2 texcoord = gl_FragCoord.xy/buffersize;
	float depth = texture2D(texture1,texcoord).x;
	vec4 diffuse = texture2D(texture0,texcoord);
	vec4 cnormal = texture2D(texture2,texcoord);
	vec4 ambient=gl_LightSource[0].ambient;
	
	float selfillumination = texture2D( texture3, texcoord ).z;
	
	// Full-bright
	if ((cnormal.x+cnormal.y+cnormal.z)>2.9) {
		ambient=vec4(1.0);
	}
	
	vec4 glow=vec4(0);
	#ifdef LW_GLOW
		glow = texture2D(texture7,texcoord);
		ambient *= 1.0-glow.w;
	#endif
	
	gl_FragData[0] = glow + diffuse * ambient * (1.0 - int(depth)) + diffuse * int(depth);
	gl_FragDepth = depth;
}
