// from Microsoft's and Ati's implementation thank them for the source :)
// Compute the ray direction for intersecting the height field profile with 
// current view ray. See the above paper for derivation of this computation. (Ati's comment)
	 
// Compute initial parallax displacement direction: (Ati's comment)
vec2 vparallaxdirection = normalize(eyevec).xy;
   
// The length of this vector determines the furthest amount of displacement: (Ati's comment)
float flength         = length( eyevec );
float fparallaxlength = sqrt( flength * flength - eyevec.z * eyevec.z ) / eyevec.z; 
   
// Compute the actual reverse parallax displacement vector: (Ati's comment)
vec2 vParallaxOffsetTS = vparallaxdirection * fparallaxlength;
   
// Need to scale the amount of displacement to account for different height ranges
// in height maps. This is controlled by an artist-editable parameter: (Ati's comment)
vParallaxOffsetTS *= depthP; 
	   
int nNumSamples;
nNumSamples = int((mix( nMinSamples, nMaxSamples, 1-dot( vparallaxdirection, N.xy ) )));	//In reference shader: int nNumSamples = (int)(lerp( nMinSamples, nMaxSamples, dot( eyeDirWS, N ) ));
float fStepSize = 1.0 / float(nNumSamples);	
float fCurrHeight = 0.0;
float fPrevHeight = 1.0;
float fNextHeight = 0.0;
int    nStepIndex = 0;
vec2 vTexOffsetPerStep = fStepSize * vParallaxOffsetTS;
vec2 vTexCurrentOffset = texcoord.xy;
float  fCurrentBound     = 1.0;
float  fParallaxAmount   = 0.0;

vec2 pt1 = vec2(0,0);
vec2 pt2 = vec2(0,0);	    
				
while ( nStepIndex < nNumSamples ) 
{
	vTexCurrentOffset -= vTexOffsetPerStep;

	// Sample height map which in this case is stored in the alpha channel of the normal map: (Ati's comment)
	fCurrHeight = texture2D( LW_DIFFUSE, vTexCurrentOffset).a; 

	fCurrentBound -= fStepSize;

	if ( fCurrHeight > fCurrentBound ) 
	{   
	   pt1 = vec2( fCurrentBound, fCurrHeight );
	   pt2 = vec2( fCurrentBound + fStepSize, fPrevHeight );

	   nStepIndex = nNumSamples + 1;	//Exit loop
	   fPrevHeight = fCurrHeight;
	}
	else
	{
	   nStepIndex++;
	   fPrevHeight = fCurrHeight;
	}
} 
float fDelta2 = pt2.x - pt2.y;
float fDelta1 = pt1.x - pt1.y;
  
float fDenominator = fDelta2 - fDelta1;
  
// SM 3.0 requires a check for divide by zero, since that operation will generate
// an 'Inf' number instead of 0, as previous models (conveniently) did: (Ati's comment)
if ( fDenominator == 0.0 )
{
	fParallaxAmount = 0.0;
}
else
{
	fParallaxAmount = (pt1.x * fDelta2 - pt2.x * fDelta1 ) / fDenominator;
}
vec2 vParallaxOffset = vParallaxOffsetTS * (1 - fParallaxAmount );
texcoord = texcoord - vParallaxOffset;        

vLightTS = T * vLightTS.x + B * vLightTS.y + N * vLightTS.z;
vec2 vLightRayTS = vLightTS.xy * depthP;
// Compute the soft blurry shadows taking into account self-occlusion for
// features of the height field:
float sh0 = texture2D( LW_DIFFUSE, texcoord).a;
//float sh7 = (texture2D( LW_DIFFUSE, texcoord + vLightRayTS * 0.55).a - sh0 - 0.55 ) * 6;
//float sh6 = (texture2D( LW_DIFFUSE, texcoord + vLightRayTS * 0.44).a - sh0 - 0.44 ) * 8;
//float sh5 = (texture2D( LW_DIFFUSE, texcoord + vLightRayTS * 0.33).a - sh0 - 0.33 ) * 10;
//float sh4 = (texture2D( LW_DIFFUSE, texcoord + vLightRayTS * 0.22).a - sh0 - 0.22 ) * 12;
// Compute the actual shadow strength:
//fOcclusionShadow = 1 - max( max( max(  sh7, sh6 ), sh5 ), sh4 );
// The previous computation overbrightens the image, let's adjust for that:
//fOcclusionShadow = fOcclusionShadow* .1+.45;

//diffuse *= fOcclusionShadow;

