#extension GL_ARB_draw_buffers : enable

uniform vec3 cameraposition;
uniform vec2 buffersize;
uniform vec2 camerarange;

include "abstract::greyscale.txt"
include "abstract::DepthToZPosition.frag"

#ifdef LW_DETAIL
	uniform sampler2D LW_DETAIL;
#endif

#ifdef LW_DIFFUSE
	uniform sampler2D LW_DIFFUSE;
#endif

#ifdef LW_DIFFUSE2
	uniform sampler2D LW_DIFFUSE2;
#endif

#ifdef LW_SPECULARMAP
	uniform sampler2D LW_SPECULARMAP;
#endif

#ifdef LW_BUMPMAP
	uniform sampler2D LW_BUMPMAP;
#endif

#ifdef LW_BUMPMAP2
	uniform sampler2D LW_BUMPMAP2;
#endif

#ifdef LW_BLOOM
	uniform sampler2D LW_BLOOM;
#endif

#ifdef LW_CUBEMAP
	uniform samplerCube LW_CUBEMAP;
	varying vec3 cubemapdir;
	varying vec3 cubemapnormal;
#endif

#ifdef LW_GIMAP
	uniform sampler2D LW_GIMAP;
#endif

#ifdef LW_PARALLAXMAP
	uniform sampler2D LW_PARALLAXMAP;
	varying vec3 eyevec;
#endif

#ifdef LE_REFRACTION
	uniform sampler2D LE_REFRACTION;
	uniform sampler2D LE_DEPTHBUFFER;
	uniform float refractionstrength = 0.01;
#endif

#ifdef LW_POMMAP
	vec3 vLightTS=vec3(0.577,0.577,0.577);
	varying vec3 eyevec;
	float depthP = 0.01;
	float nMinSamples = 20;
	float nMaxSamples = 50;	
#endif

#ifdef LW_MESHLAYER
	varying float vegetationfade;
#endif

#ifdef LW_ALPHABLEND
	uniform sampler2D LW_ALPHABLEND_INCOMINGCOLOR;
	uniform sampler2D LW_ALPHABLEND_INCOMINGNORMAL;
#endif

varying vec3 vertexposition;
varying vec3 T,B,N;
varying vec2 texcoord0;
varying vec2 texcoord1;
varying vec4 modelvertex;
varying vec4 fragcolor;

float fOcclusionShadow = 1.0;

uniform sampler2D texture14;
uniform float terrainsize;
uniform vec3 terrainscale;
uniform float bumpscale;
uniform float specular;
uniform float gloss;

//Terrain color map
uniform sampler2D texture12;

void main(void) {
	discard;
}
