Include "MeshMatrix.vert"

varying vec2 texcoord0;
uniform float apptime;
uniform vec3 cameraposition;
uniform float meshlayerrange;
uniform float meshlayerheight;
uniform float vegetationviewdistance;
uniform float vegetationheight;

void main(void) {
	
	vec4 modelvertex = gl_Vertex;
	
	Include "GetMatrix.vert"

	#ifdef LW_SKIN
		mat  = GetAnimMatrix( int(boneindices[0]) ) * gl_Color[0];
		mat += GetAnimMatrix( int(boneindices[1]) ) * gl_Color[1];
		mat += GetAnimMatrix( int(boneindices[2]) ) * gl_Color[2];
		mat += GetAnimMatrix( int(boneindices[3]) ) * gl_Color[3];
		//mat = animmatrix[ int(boneindices[0]) ] * gl_Color[0];
		//mat += animmatrix[ int(boneindices[1]) ] * gl_Color[1]; 
		//mat += animmatrix[ int(boneindices[2]) ] * gl_Color[2];
		//mat += animmatrix[ int(boneindices[3]) ] * gl_Color[3];
	#endif

	#ifdef LW_MESHLAYER
		mat[3].y=0.0;
	#endif
		
	modelvertex = mat * modelvertex;

	#ifdef LW_MESHLAYER
		//Align to terrain height
		modelvertex.y += GetTerrainHeight(modelvertex.xz);
		float mld = length(modelvertex.xyz - cameraposition )/vegetationviewdistance;
		mld = clamp( (mld-0.75)*4.0, 0.0, 1.0 );
		modelvertex.y -= mld * vegetationheight;
	#endif

	#ifdef LW_SWAY
		float seed = mod(apptime / 100.0 * 0.25,360.0);
		seed += mat[3].x*33.0 + mat[3].y*67.8 + mat[3].z*123.5;
		seed += gl_Vertex.x + gl_Vertex.y + gl_Vertex.z;
		vec4 movement = vec4( vec3( gl_Color.x * gl_Normal * LW_SWAY * (sin(seed)+0.25*cos(seed*5.2+3.2)) ),0.0);		
		modelvertex += movement;
	#endif
		
	gl_Position = gl_ModelViewProjectionMatrix * modelvertex;

	texcoord0=gl_MultiTexCoord0.xy;
	
	#ifdef __GLSL_CG_DATA_TYPES
		gl_ClipVertex = gl_ModelViewMatrix * modelvertex;
	#endif
	
	gl_FrontColor = vec4(0);
	
}
