Include "MeshMatrix.vert"

uniform float aspect;
uniform float apptime;
uniform vec3 cameraposition;
uniform float MajorWaveSpeed = 0.01;
uniform float MajorWaveScale = 0.005;
uniform float MinorWaveSpeed = 0.01;
uniform float MinorWaveScale = 0.005;
uniform float MajorWaveHeight = 4.0;
uniform vec2 camerarange;
uniform float camerazoom;

varying vec4 projectspace;
varying vec2 texcoord;
varying vec3 T,B,N;
varying vec4 modelvertex;
varying vec4 refractionspace;
varying vec4 fragcolor;

#define COS22 0.924
#define SIN22 0.383


void main(){
		
	Include "GetMatrix.vert"

	fragcolor = gl_Color * color;

	//mat3 nmat = mat3(mat[0].xyz,mat[1].xyz,mat[2].xyz);
	modelvertex=mat*gl_Vertex;
	texcoord = modelvertex.xz;
	
	float waveheight = 0.0;

	//appseconds=50.0;

	projectspace = gl_ModelViewProjectionMatrix * modelvertex;  

	gl_Position = projectspace;

	refractionspace = projectspace;
	projectspace.xy = (projectspace.xy / camerazoom + vec2(projectspace.w)) * 0.5;
	refractionspace.xy = (refractionspace.xy + vec2(refractionspace.w)) * 0.5; 

	T = gl_NormalMatrix * vec3(1,0,0);
	B = gl_NormalMatrix * vec3(0,0,1);
	N = gl_NormalMatrix * vec3(0,1,0);
	
	#ifdef __GLSL_CG_DATA_TYPES
		gl_ClipVertex = modelvertex;//gl_ModelViewMatrix * mat * gl_Vertex;
	#endif

}
