uniform sampler2D texture0;// reflection normal map
uniform sampler2D texture3;// refraction color buffer
uniform sampler2D texture4;// refraction depth buffer
uniform vec2 camerarange;
uniform float camerazoom;
uniform vec2 buffersize;
#define waveamplitude 2.0
#define wavespeed 0.00001
#define wavesize 20.0
uniform float apptime;

varying vec4 fragcolor;

varying vec2 texcoord;
varying vec4 modelvertex;

float DepthToZPosition(in float depth) {
	return camerarange.x / (camerarange.y - depth * (camerarange.y - camerarange.x)) * camerarange.y;
}

void main() {
	
	vec4 refraction;
	vec4 refractionvector;
	vec3 normal;
	vec4 bumpcolor;
	
	bumpcolor= texture2D(texture0,modelvertex.xz/wavesize+apptime*wavespeed).xyz * 2.0 - 1.0;
	bumpcolor+=texture2D(texture0,modelvertex.xz/wavesize-apptime*wavespeed+0.5).xyz * 2.0 - 1.0;
	bumpcolor+=texture2D(texture0,vec2(texcoord.y/wavesize/4.0,texcoord.x/wavesize/4.0 + apptime / 50000.0 / 2.0 ));
	bumpcolor+=texture2D(texture0,vec2(texcoord.y/wavesize/4.0+0.5,texcoord.x/wavesize/4.0 - apptime / 50000.0 / 2.0 ));
	bumpcolor/=4.0;
	normal = bumpcolor.xyz - 0.5;
	normal.z /= 2.0;
	normal = normalize(normal);
	
	refractionvector = vec4( gl_FragCoord.x/buffersize.x, gl_FragCoord.y/buffersize.y, gl_FragCoord.z, 1.0 );
	
	vec4 refractionvector2 = refractionvector + 0.05 * vec4(normal,0.0);		
	if (gl_FragCoord.z<DepthToZPosition(texture2DProj(texture4,refractionvector2).x)) {
		refractionvector=refractionvector2;
	}
	refraction=texture2DProj(texture3,refractionvector);	
		
	gl_FragColor = refraction * fragcolor;
	
}
