#extension GL_ARB_draw_buffers : enable

uniform samplerCube texture0;
uniform vec4 fogcolor;
uniform vec2 fogangle;

varying vec3 cubecoord;
varying vec4 fragcolor;

void main(void) {
	vec4 color=textureCube(texture0,cubecoord) * fragcolor;
	
	//Horizon fog effect
	vec3 normal=normalize(cubecoord);
	normal.y=max(normal.y,0.0);
	float angle=asin(normal.y)*57.2957795-fogangle.x;
	float fogeffect=1.0-clamp(angle/(fogangle.y-fogangle.x),0.0,1.0);
	fogeffect *= fogcolor.w;
	color=color*(1.0-fogeffect)+fogeffect*fogcolor;
	
	gl_FragData[0] = color;
	gl_FragData[1] = vec4(1.0,1.0,1.0,0.0);
	gl_FragData[2] = vec4(0.0);
	gl_FragData[3] = vec4(0.0);//color*0.5*0.25*(1.0-fogeffect);
}