uniform sampler2D texture0;// reflection normal map
uniform sampler2D texture3;// refraction color buffer
uniform sampler2D texture4;// refraction depth buffer
uniform sampler2D texture6;

uniform float frameinterpolation;

uniform vec2 camerarange;
uniform float camerazoom;
uniform vec2 buffersize;
#define waveamplitude 2.0
#define wavespeed 0.00001
#define wavesize 64.0
uniform float apptime;
varying vec4 fragcolor;

varying vec2 texcoord;
varying vec4 modelvertex;

uniform vec2 fogrange;
uniform vec4 fogcolor;

uniform float wavescale;

Include "abstract::DepthToZPosition.frag"

void main() {
	
	vec4 refraction;
	vec4 refractionvector;
	vec3 normal;

	float lineardepth = DepthToZPosition(gl_FragCoord.z);
	float fogeffect = clamp( 1.0 - (fogrange.y - lineardepth) / (fogrange.y - fogrange.x) , 0.0, 1.0 ) * fogcolor.w;
	
	normal  = ((1.0-frameinterpolation)*texture2D(texture0,modelvertex.xz*0.25)  + frameinterpolation*texture2D(texture6,modelvertex.xz*0.25)).xyz  * 2.0 - 1.0;
	normal += 0.5*(((1.0-frameinterpolation)*texture2D(texture0,modelvertex.zx*0.1+0.135) + frameinterpolation*texture2D(texture6,modelvertex.zx*0.1+0.135)).xyz * 2.0 - 1.0);
	normal = normalize(normal);

	normal.x *= wavescale;
	normal.y *= wavescale;
	
	refractionvector = vec4( gl_FragCoord.x/buffersize.x, gl_FragCoord.y/buffersize.y, gl_FragCoord.z, 1.0 );
	
	vec4 refractionvector2 = refractionvector + 0.25 * vec4(normal,0.0);		
	if (gl_FragCoord.z<DepthToZPosition(texture2DProj(texture4,refractionvector2).x)) {
		refractionvector=refractionvector2;
	}
	refraction=texture2DProj(texture3,refractionvector);	
	
	vec4 color = refraction * fragcolor;
	color = color * (1.0-fogeffect) + fogcolor * fogeffect;
	gl_FragColor = color;
}
