#extension GL_ARB_draw_buffers : enable

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform vec2 buffersize;

varying vec2 texcoord0;
varying float ParticleSize;

void main(void) {
	vec2 screencoord = vec2( gl_FragCoord.x/buffersize.x, gl_FragCoord.y/buffersize.y );
	vec4 color = texture2D( texture0, texcoord0 );
	if (color.a==0.0) {
		discard;
		}
	float alpha = color.a * gl_Color.a;		
	gl_FragData[0] = color * alpha + (1.0-alpha) * texture2D(texture1,screencoord);
	gl_FragData[2] = vec4(0.0);
}
