uniform sampler2D texture0;// normal + alpha map
uniform sampler2D texture1;// background
uniform sampler2D texture2;// depth
uniform sampler2D texture3;// heat haze texture
uniform vec2 buffersize;
uniform vec2 camerarange;
uniform float refractionstrength=0.025;

varying vec2 texcoord0;

Include "abstract::DepthToZPosition.frag"

void main(void) {
	
	float alpha=gl_Color.w;
	
	vec4 color = gl_Color * texture2D( texture0, texcoord0 );
	
	alpha *= color.w;

	//if (color.a<0.003) {
	//	discard;
	//}
	
	vec3 normal = texture2D(texture3,gl_FragCoord.xy/buffersize/0.1).xyz * 2.0 - 1.0;
	
	normal = alpha * normal + (1.0-alpha) * vec3(0,0,1);
	
	vec4 refractionvector = vec4( gl_FragCoord.x/buffersize.x, gl_FragCoord.y/buffersize.y, gl_FragCoord.z, 1.0 );
	refractionvector += refractionstrength * vec4(normal,0.0);		
	
	if (gl_FragCoord.z>DepthToZPosition(texture2DProj(texture2,refractionvector).x)) {
		discard;
	}
	
	vec4 haze = texture2DProj(texture1,refractionvector);
	
	gl_FragColor = vec4( haze.xyz, color.w );		

}
