uniform sampler2D texture0;// diffuse
uniform sampler2D texture1;// normal + alpha map
uniform sampler2D texture2;// background
uniform sampler2D texture3;// depth
uniform vec2 buffersize;
uniform vec2 camerarange;
#define refractionstrength 0.5

varying vec2 texcoord0;

Include "abstract::DepthToZPosition.frag"

void main(void) {
	
	vec4 diffuse;
	vec3 normal;
	vec3 refraction;	
	vec4 refractionvector;

	//Get diffuse
	diffuse = gl_Color * texture2D( texture0, texcoord0 );
	if (diffuse.w<0.003) {
		discard;
	}
	
	//Get normal
	normal = texture2D( texture1, texcoord0 ).xyz * 2.0 - 1.0;
	normal = normal * diffuse.w + vec3(0,0,1) * (1.0-diffuse.w);
	
	//Calculate refraction vector
	refractionvector = vec4( gl_FragCoord.x/buffersize.x, gl_FragCoord.y/buffersize.y, gl_FragCoord.z, 1.0 );
	refractionvector += refractionstrength * vec4(normal,0.0);		
	
	if (gl_FragCoord.z>DepthToZPosition(texture2DProj(texture3,refractionvector).x)) {
		discard;
	}
	
	refraction = texture2DProj(texture2,refractionvector).xyz;
	
	gl_FragColor = vec4( refraction, diffuse.w ) + 0.5 * vec4(diffuse.xyz,0.0);
}
