#extension GL_ARB_draw_buffers : enable

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform vec2 camerarange;
uniform vec2 buffersize;

varying vec2 texcoord0;
varying float particlesize;
varying vec4 fake_FragCoord1;

float DepthToZPosition(in float depth) {
	return camerarange.x / (camerarange.y - depth * (camerarange.y - camerarange.x)) * camerarange.y;
}

#define nearfade 0.1

void main(void) {
	
	vec3 fake_FragCoord;
	fake_FragCoord.x = ((fake_FragCoord1.x/fake_FragCoord1.w)*0.5+0.5)*buffersize.x;
	fake_FragCoord.y = ((fake_FragCoord1.y/fake_FragCoord1.w)*0.5+0.5)*buffersize.y;
	fake_FragCoord.z = 0.5*fake_FragCoord1.z/fake_FragCoord1.w+0.5;
	fake_FragCoord=gl_FragCoord.xyz;
	
	float depthfade=1.0;
	vec2 screencoord = fake_FragCoord.xy/buffersize;

	float depth = texture2D( texture1, screencoord ).x;
	float linearbackgrounddepth = DepthToZPosition( depth );
	float lineardepth = DepthToZPosition( gl_FragCoord.z );
	float neardistancefade = clamp( lineardepth - nearfade, 0.0, 1.0 );	

	depthfade = clamp(-(lineardepth - linearbackgrounddepth)/ particlesize, 0.0, 1.0 );
	
	vec4 color =  gl_Color * texture2D( texture0, texcoord0 ) * vec4( 1.0,1.0,1.0,depthfade*neardistancefade);
	if (color.a<0.003) {
		discard;
	}
	gl_FragData[0] = color;

	/*	
	float depth = texture2D( texture1, screencoord ).x;
	float linearbackgrounddepth = DepthToZPosition( depth );
	float lineardepth = fake_FragCoord.z;//DepthToZPosition( fake_FragCoord.z );
	float neardistancefade = clamp( lineardepth - nearfade, 0.0, 1.0 );	

	depthfade = 1.0-clamp(linearbackgrounddepth-lineardepth, 0.0, 1.0 );
	//depthfade=1.0;
	
	vec4 color =  gl_Color * texture2D( texture0, texcoord0 ) * vec4( 1.0,1.0,1.0,depthfade*neardistancefade);
	if (color.a<0.003) {
	//	discard;
	}
	//gl_FragData[0]=color;
	gl_FragData[0]=vec4(depth,depth,depth,1.0);
	//gl_FragData[0]=clamp( texture2D( texture1, screencoord ), 0.0, 1.0) ;
	*/
}
