#define samples 20.0
#define samplesi 20

uniform sampler2D texture0;
uniform vec2 buffersize;

vec4 clampvec4(in vec4 color) {
	color.x=max(color.x,0.0);
	color.y=max(color.y,0.0);
	color.z=max(color.z,0.0);
	color.w=max(color.w,0.0);
	return color;
}

void main( void ) {
	
	vec2 ps = 1.0/buffersize;
	vec4 color;
	vec2 coord = gl_FragCoord.xy/buffersize;
	vec4 bloomsample;
	
	//Loop causes black squares with HDR on NVidia cards
	for ( int i = 0; i < samplesi; i++ ) {
		coord.x=gl_FragCoord.x/buffersize.x-ps.x*samples*0.5+float(i)*ps.x;
		coord.y=gl_FragCoord.y/buffersize.y;
		bloomsample = texture2D(texture0,coord);
		//bloomsample *= bloomsample.w;
		//bloomsample.x = bloomsample.x * bloomsample.w;
		//bloomsample.y = bloomsample.y * bloomsample.w;
		//bloomsample.z = bloomsample.z * bloomsample.w;
		color += clampvec4(bloomsample);
	}
	
	gl_FragColor = color/samples;
}
