#define samples 10.0
#define samplesi 10

uniform sampler2D texture0;
//uniform sampler2D texture1; //texture for secondary bounce
uniform vec2 buffersize;

float luminance( in vec4 color ) {
	return color.r * 0.3 + color.g * 0.59 + color.b * 0.11; 
}

vec4 clampvec4(in vec4 color) {
	color.x=max(color.x,0.0);
	color.y=max(color.y,0.0);
	color.z=max(color.z,0.0);
	color.w=max(color.w,0.0);
	return color;
}

void main( void ) {
	vec2 ps = 1.0 / buffersize;
	vec4 color;
	vec2 coord;
	vec4 sample;	
	float weight;
	float totalweight;


	for ( int i = 0; i < samplesi; i++ ) {
		coord.y=gl_FragCoord.y/buffersize.y-ps.y*samples*0.5+i*ps.y;
		coord.x=gl_FragCoord.x/buffersize.x;
		sample = clampvec4(texture2D(texture0,coord));
		//sample *= sample.w;
		color += sample;
	}
	gl_FragColor = color/samples;
}