#ifdef DOFMODE==1
	#define samples 10.0
	#define samplesi 10	
#else
	#define samples 24.0
	#define samplesi 24
#endif

include "abstract::clampvec4.frag"

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform vec2 buffersize;
uniform vec2 dofnearrange;
uniform vec2 doffarrange;
uniform vec2 camerarange;

Include "abstract::depthtozposition.frag"

void main( void ) {
	vec2 ps = 1.0 / buffersize;
	vec4 color;
	vec2 coord;
	float validsamples;
	float z;
	vec4 sample;
	float nearblurstrength=0.0;
	float farblurstrength=0.0;
	float mix;
	float blurstrength;
	float samplenearblurstrength;	
	float samplefarblurstrength;
	float sampleblurstrength;	
	
	//First sample own pixel
	coord.x=gl_FragCoord.x/buffersize.x;
	coord.y=gl_FragCoord.y/buffersize.y;
	color=texture2D(texture0,coord);
	validsamples=1.0;
	
	z=DepthToZPosition(texture2D(texture1,coord).x);
	#ifdef DOFMODE==1
		blurstrength = clamp((z-doffarrange.x)/(doffarrange.y-doffarrange.x),0.0,1.0);			
	#else
		blurstrength =  clamp(1.0-(z-dofnearrange.x)/(dofnearrange.y-dofnearrange.x),0.0,1.0);
	#endif
	
	#ifdef DOFMODE==1
	#else
		for ( int i = 0; i < samplesi; i++ ) {
			mix=1.0-abs((float(i)-(samples/2.0))/(samples/2.0));
			//mix=min(mix*2.0,1.0);
			coord.x=gl_FragCoord.x/buffersize.x-ps.x*samples*0.5+i*ps.x;
			coord.y=gl_FragCoord.y/buffersize.y;
			sample = texture2D(texture0,coord);
			z=DepthToZPosition(texture2D(texture1,coord).x);
			sampleblurstrength =  clamp(1.0-(z-dofnearrange.x)/(dofnearrange.y-dofnearrange.x),0.0,1.0);
			blurstrength=max(blurstrength,sampleblurstrength*mix);
		}	
	#endif
	
	for ( int i = 0; i < samplesi; i++ ) {
		coord.x=gl_FragCoord.x/buffersize.x-ps.x*samples*0.5+i*ps.x;
		coord.y=gl_FragCoord.y/buffersize.y;
		sample = texture2D(texture0,coord);
		
		#ifdef DOFMODE==1			
			z=DepthToZPosition(texture2D(texture1,coord).x);
			sampleblurstrength = clamp((z-doffarrange.x)/(doffarrange.y-doffarrange.x),0.0,1.0);
			color += sample * sampleblurstrength;
			validsamples += sampleblurstrength;
			//blurstrength+=sampleblurstrength;
		#else
			mix=1.0-abs((float(i)-(samples/2.0))/(samples/2.0));
			//mix=min(mix*2.0,1.0);
			color += sample * mix;
			validsamples += mix;
		#endif
	}
	
	#ifdef DOFMODE==1
	//	blurstrength /= samples;
	#endif
	
//	gl_FragColor.x = clamp(color.x/validsamples,0,1);
//	gl_FragColor.y = clamp(color.y/validsamples,0,1);
//	gl_FragColor.z = clamp(color.z/validsamples,0,1);
//	gl_FragColor.w = blurstrength;
	//blurstrength=0.0;
	gl_FragColor=clampvec4(vec4(color.xyz/validsamples,blurstrength));
}