#ifdef DOFMODE==1
	#define samples 5.0
	#define samplesi 5	
#else
	#define samples 12.0
	#define samplesi 12
#endif

uniform sampler2D texture0;
uniform vec2 buffersize;

include "abstract::clampvec4.frag"

void main( void ) {
	vec2 ps = 1.0 / buffersize;
	vec4 color;
	vec2 coord;
	vec4 sample;
	float validsamples;
	float blurstrength;	
	float mix;

	coord.x=gl_FragCoord.x/buffersize.x;
	coord.y=gl_FragCoord.y/buffersize.y;
	color=texture2D(texture0,coord);
	validsamples=1.0;
	blurstrength=color.w;
	
	#ifdef DOFMODE==1
	#else
		for ( int i = 0; i < samplesi; i++ ) {
			coord.x=gl_FragCoord.x/buffersize.x;
			coord.y=gl_FragCoord.y/buffersize.y-ps.y*samples*0.5+i*ps.y;
			sample = texture2D(texture0,coord);
			mix=1.0-abs((float(i)-(samples/2.0))/(samples/2.0));
			//mix=min(mix*2.0,1.0);
			blurstrength=max(blurstrength,sample.w*mix);		
		}
	#endif

	for ( int i = 0; i < samplesi; i++ ) {
		coord.x=gl_FragCoord.x/buffersize.x;
		coord.y=gl_FragCoord.y/buffersize.y-ps.y*samples*0.5+i*ps.y;
		sample = texture2D(texture0,coord);
		
		#ifdef DOFMODE==1
			color.x += sample.x*sample.w;
			color.y += sample.y*sample.w;
			color.z += sample.z*sample.w;
			color.w += sample.w;
			validsamples += sample.w;
		#else
			mix=1.0-abs((float(i)-(samples/2.0))/(samples/2.0));
			//mix=min(mix*2.0,1.0);
			color.x += sample.x*mix;//blurstrength*mix;
			color.y += sample.y*mix;//blurstrength*mix;
			color.z += sample.z*mix;//blurstrength*mix;
			color.w += sample.w*mix;//blurstrength*mix;
			validsamples += mix;//blurstrength*mix;		
		#endif
	}

	gl_FragColor = clampvec4(vec4(color.xyz / validsamples, blurstrength));
}