//==========================================
// HDR calculation
//==========================================

// Sample the 4x4 texture to get an average
vec4 exposurecolor;
exposurecolor  = texture2D(texture4,vec2(0.0*0.25+0.125,0.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(1.0*0.25+0.125,0.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(2.0*0.25+0.125,0.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(3.0*0.25+0.125,0.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(0.0*0.25+0.125,1.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(1.0*0.25+0.125,1.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(2.0*0.25+0.125,1.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(3.0*0.25+0.125,1.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(0.0*0.25+0.125,2.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(1.0*0.25+0.125,2.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(2.0*0.25+0.125,2.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(3.0*0.25+0.125,2.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(0.0*0.25+0.125,3.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(1.0*0.25+0.125,3.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(2.0*0.25+0.125,3.0*0.25+0.125));
exposurecolor += texture2D(texture4,vec2(3.0*0.25+0.125,3.0*0.25+0.125));
exposurecolor /= 16.0;

// Get the average luminance
float avgLuminance = exposurecolor.r * 0.3 + exposurecolor.g * 0.59 + exposurecolor.b * 0.11;

// Here's the tone mapping calculation.  I wanted the exposure to never be darker than the normal
// light level.  I didn't want the exposure to fluctuate when in the bright range, but I wanted
// dark lighting to have a strong effect on the exposure.  A few dark objects on the screen shouldn't make the 
// exposure lighter, but in a dark room a bright window will have a visible effect.  The following equation
// provides the behavior I was looking for:

irisadjustment = 1.0 / (avgLuminance/0.25);
irisadjustment = clamp(irisadjustment,1.0,2.0);
outputcolor *= irisadjustment;

bloomirisadjustment=irisadjustment;