//attribute float terrainheight;

uniform vec2 terrainsectoroffset;
uniform float height;
uniform float terrainaltitude;

include "abstract::meshmatrix.vert"

varying vec3 texcoord0;
varying vec2 texcoord1;
varying vec3 vertexposition;
varying vec4 modelvertex;
varying vec3 T,B;
varying vec3 worldvertex;

//include "abstract::getterrainheight.vert"

void main(void) {
	
	include "abstract::getmatrix.vert"
	
	vec4 v = vec4( gl_Vertex.x, 0.0, gl_Vertex.z, 1.0 );
	
	v.x = v.x*terrainscale.x+mat[3].x;
	v.z = v.z*terrainscale.z+mat[3].z;
	
	texcoord0 = v.xyz;
	texcoord0.z *= -1.0;
	
	float terrainresolution = terrainsize / terrainscale.x;

	texcoord1.x = ( mat[3].x+gl_Vertex.x*terrainscale.x) / terrainsize + 0.5 - 0.5/terrainresolution;
	texcoord1.y = ( 1.0-(mat[3].z+gl_Vertex.z*terrainscale.z)) / terrainsize + 0.5 - 0.5/terrainresolution;
	
	texcoord1.x += 0.5/(terrainsize/terrainscale.x);
	texcoord1.y -= 0.5/(terrainsize/terrainscale.x);

	v.y = GetTerrainHeight(v.xz);//texture2D(texture15,vec2(1.0-texcoord1.y,texcoord1.x)).x * terrainaltitude;
	texcoord0.y=v.y;	

	gl_Position = gl_ModelViewProjectionMatrix * v;
	
	T = gl_NormalMatrix * vec3(1.0,0.0,0.0);
	B = gl_NormalMatrix * vec3(0.0,0.0,-1.0);
	
	gl_FrontColor = gl_Color;
	
	vertexposition = v.xyz;

	#ifdef __GLSL_CG_DATA_TYPES
		gl_ClipVertex = gl_ModelViewMatrix * v;
	#endif
	
}
