#define amplitude 0.1

uniform sampler2D texture0;
uniform sampler2D texture1;
uniform sampler2D texture2;
uniform float AppTime;

varying vec3 T,B,N;
varying vec4 projectSpace;
varying vec2 texcoord;
varying vec4 ModelVertex;
//varying vec3 reflectdir;

void main(){
	vec3 normal;
	vec4 bumpcolor;
	bumpcolor = texture2D(texture1,vec2(texcoord.x*4.0,texcoord.y*4.0 + AppTime / 10000.0));
	bumpcolor = (bumpcolor+texture2D(texture1,vec2(texcoord.x*4.0+0.5,texcoord.y*4.0 + AppTime / 20000.0)) )/2.0;	
	normal = normalize(bumpcolor.xyz - 0.5);
	normal = T * normal.x + B * normal.y + N * normal.z;
	normal = cross(normal,N);
	//normal = cross( normal, reflectdir);

	//vec4 adjustedprojspace = projectSpace;
	//adjustedprojspace.y = adjustedprojspace.y*0.75+0.125;
	
	vec4 color = texture2DProj(texture0, projectSpace + amplitude * vec4(normal.x,normal.y,normal.z,0.0) ) * gl_Color;
	//color *= texture2D(texture2,vec2(texcoord.x*4.0+0.5,texcoord.y*4.0 + AppTime / 20000.0) );
	
	gl_FragColor=color;
	gl_FragColor.a=gl_Color.a;
}
