'##################################################################################################
'Flags
Const ANIMATION_PLAYONCE:Int = 1

'##################################################################################################
Type TAnimation
	
	'################################################
	Field Name:String
	Field StartFrame:Int, EndFrame:Int, CurrentFrame:Float
	Field Speed:Float, LoopCount:Int, Flags:Int
	
	'################################################
	Function Create:TAnimation( Name:String, StartFrame:Int, EndFrame:Int, Flags:Int = 0, Speed:Float = 0.5 )
		
		Local A:TAnimation = New TAnimation
		A.Name = Name
		A.StartFrame = StartFrame
		A.EndFrame = EndFrame
		A.Speed = Speed
		A.Flags = Flags
		A.LoopCount = 0
		A.Reset()
		Return( A )
		
	End Function
	
	Method Reset()
		CurrentFrame = StartFrame
	End Method
	
	Method Play( TargetModel:TEntity )
		If CurrentFrame + (Speed * AppSpeed() ) < EndFrame
			CurrentFrame = CurrentFrame + (Speed * AppSpeed() )
		Else
			CurrentFrame = EndFrame
			If Not (Flags & ANIMATION_PLAYONCE)
				Reset()
				LoopCount:+1
			EndIf
		EndIf
		
		Animate( TargetModel, CurrentFrame, 1.0, 0, True )
	End Method
	
	Function Debug( TargetModel:TEntity, Frame:Float )
		Animate( TargetModel, Frame, 1.0, 0, True )
	End Function
	
	'################################################

End Type

'##################################################################################################
