'##################################################################################################
Type TApp
	
	Global Name:String = "MarioLWE"
	Global Version:String = ""
	Global Mode:String = "Animation Demo"
	Global Debug:Int = 0
	Global ZipPassword:String = "AW3S0M3"
	
	Global GWidth:Int = 1920
	Global GHeight:Int = 1200
	
	Global MainWorld:TWorld
	Global MainCam:TCamera
	
	Global SkyBoxWorld:TWorld
	Global SkyBoxCam:TCamera
	Global SkyBoxMesh:TMesh
	
	Function AbstractZipDir:String( Path:String )
		If FileType( StripSlash( Path ) ) = FILETYPE_DIR Then Return Path
		
		Local ZipPath:String = StripSlash( Path ) + ".pak"
		If FileType( ZipPath ) <> FILETYPE_FILE Then Return "zip::" + ZipPath + "\\"
		
		SetZipStreamPassword( ZipPath, ZipPassword )
		Return "zip::" + ZipPath + "\\"
	End Function
	
	Function AbstractZipFile:String( FilePath:String )
		Local Path:String = FilePath
		If FileType( Path ) = FILETYPE_FILE Then Return Path
		
		Local ZipPath:String = StripSlash( ExtractDir( Path ) ) + ".pak"
		If FileType( ZipPath ) <> FILETYPE_FILE Then Return Path + " <=> " + ZipPath
		
		SetZipStreamPassword( ZipPath, ZipPassword )
		Return "zip::"+ZipPath+"\\"+StripDir( Path )
	End Function
	
	Function CreateMainWorld()
		MainWorld = CreateWorld()
		MainCam = CreateCamera()
		CameraClearMode( MainCam, BUFFER_DEPTH )
	End Function
	
	Function CreateSkyBox()
		SkyBoxWorld = CreateWorld()
		SetWorld( SkyBoxWorld )
		
		SkyBoxCam = CreateCamera()
		
		SkyBoxMesh = CreateCube()
		FlipMesh( SkyBoxMesh )
	End Function
	
	Function PaintSkyBox( Mat:TMaterial )
		PaintEntity( SkyBoxMesh, Mat )
	End Function
	
	Function Initialize()
		LogStreamEnabled = Debug
		AppTitle = Name + " - " + Mode + " " + Version
		Graphics GWidth, GHeight, 32
		SetDirectories()
		CreateMainWorld()
		CreateSkyBox()
		SetWorld( MainWorld )
		TApp.DrawLoadingScreen()
	End Function
	
	Function SetDirectories()
		ChangeDir( "..\data\" )
		DIR_DATA = CurrentDir()
		RegisterAbstractPath( DIR_DATA )
	End Function
	
	Function DrawLoadingScreen()
		RenderWorld()
		Flip()
		Local LoadingImage:TTexture = LoadTexture( "Images\Loading01.dds" )
		DrawImage( LoadingImage, 0, 0, GWidth, GHeight )
		RenderWorld()
		Flip()
	End Function
	
End Type

'##################################################################################################
