'##################################################################################################
Type TRenderer
	
	Global PostBuffer:TBuffer
	Global GBuffer:TBuffer
	
	Global AntiAliasShader:TShader
	
	Function Initialize()
		PostBuffer = CreateBuffer( TApp.GWidth, TApp.GHeight, BUFFER_COLOR )
		GBuffer = CreateBuffer( TApp.GWidth, TApp.GHeight, BUFFER_COLOR|BUFFER_DEPTH|BUFFER_NORMAL )
	End Function
	
	Function Render()
		
		SetBuffer( GBuffer )
		
		RotateEntity( TApp.SkyBoxCam, EntityRotation( TApp.MainCam, True ) )
		SetWorld( TApp.SkyBoxWorld )
		RenderWorld()
		
		SetWorld( TApp.MainWorld )
		RenderWorld
		
		DrawEffectAntialias( GetBuffer().ColorBuffer[0], PostBuffer.DepthBuffer, GBuffer.ColorBuffer[1], TApp.MainCam )
		
		SetBuffer( PostBuffer )
		RenderLights( GBuffer )
		
		Draw2D()
		
		SetBuffer( BackBuffer() )
		DrawImage( GetColorBuffer( PostBuffer ), 0, GraphicsHeight(), GraphicsWidth(), -GraphicsHeight() )
		
		Flip( 0 )
		
	End Function
	
	Method DrawEffectAntialias( ColorTexture:TTexture, DepthTexture:TTexture, NormalTexture:TTexture, Camera:TCamera ) {hidden}
		Local Buffer:TBuffer = GetBuffer()
		AntiAliasShader = LoadShader("abstract::edge_antialiasing.vert","abstract::edge_antialiasing.frag")
		SetShader( AntiAliasShader )
		colortexture.setfilter( TEXFILTER_SMOOTH )
		colortexture.bind(1)
		normaltexture.setfilter( TEXFILTER_SMOOTH )
		normaltexture.bind(2)
		depthtexture.bind(3)
		DrawRect( 0, 0, Buffer.Width(), Buffer.Height() )
	EndMethod
	
	Function Draw2D()
		DrawText( "FPS: " + UPS(), 0, 0 )
		Select DebugAnimOn
			Case 0
				If DebugAnim <> Null
					DrawText( "Frames: " + DebugAnim.StartFrame + "-" + DebugAnim.EndFrame, 0, 20 )
					DrawText( "Animation: " + DebugAnimNR, 0, 40 )
					DrawText( "Controls", 0, 60 )
					DrawText( "WASD => Camera Control.", 0, 80 )
					DrawText( "UP/DOWN => Change Animation.", 0, 100 )
					DrawText( "Enter => Change to frame mode.", 0, 120 )
				EndIf
			Case 1
				DrawText( "Frame: " + DebugAnimFrame, 0, 20 )
				DrawText( "Speed: " + DebugAnimSpeed, 0, 40 )
				DrawText( "Controls", 0, 80 )
				DrawText( "WASD => Camera Control.", 0, 100 )
				DrawText( "UP/DOWN => Frames Control (Fast).", 0, 120 )
				DrawText( "Numpad 8/5 => Frames Control (Slow).", 0, 140 )
				DrawText( "Numpad +/. => Frame Speed Control.", 0, 160 )
				DrawText( "Enter => Change to animation mode.", 0, 180 )
		End Select
	End Function
	
End Type

'##################################################################################################
